using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using CognitiveSoftware.Algorithms.BinPacking;
using System.Threading;

namespace FileDivider
{
	/// <summary>
	/// Implements the control logic for the file seperator form
	/// </summary>
	public class FileDivider: System.Windows.Forms.Form
	{
		// form elements
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog1;
		private System.Windows.Forms.TextBox folder;
		private System.Windows.Forms.Button Browse;
		private System.Windows.Forms.TextBox size;
		private System.Windows.Forms.ComboBox sizeType;
		private System.Windows.Forms.Button sort;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox destination;
		private System.Windows.Forms.Button pickDestination;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label status;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Creates a new instance of the form
		/// </summary>
		public FileDivider()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			folder.Text = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
			folderBrowserDialog1.SelectedPath = folder.Text;
			destination.Text = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
			folderBrowserDialog2.SelectedPath = destination.Text;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FileDivider));
			this.folderBrowserDialog1 = new System.Windows.Forms.FolderBrowserDialog();
			this.folder = new System.Windows.Forms.TextBox();
			this.Browse = new System.Windows.Forms.Button();
			this.size = new System.Windows.Forms.TextBox();
			this.sizeType = new System.Windows.Forms.ComboBox();
			this.sort = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.destination = new System.Windows.Forms.TextBox();
			this.pickDestination = new System.Windows.Forms.Button();
			this.folderBrowserDialog2 = new System.Windows.Forms.FolderBrowserDialog();
			this.label3 = new System.Windows.Forms.Label();
			this.status = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// folder
			// 
			this.folder.Location = new System.Drawing.Point(104, 24);
			this.folder.Name = "folder";
			this.folder.Size = new System.Drawing.Size(480, 20);
			this.folder.TabIndex = 0;
			this.folder.Text = "";
			// 
			// Browse
			// 
			this.Browse.Image = ((System.Drawing.Image)(resources.GetObject("Browse.Image")));
			this.Browse.Location = new System.Drawing.Point(584, 24);
			this.Browse.Name = "Browse";
			this.Browse.Size = new System.Drawing.Size(32, 23);
			this.Browse.TabIndex = 1;
			this.Browse.Click += new System.EventHandler(this.Browse_Click);
			// 
			// size
			// 
			this.size.Location = new System.Drawing.Point(104, 72);
			this.size.Name = "size";
			this.size.TabIndex = 2;
			this.size.Text = "100";
			// 
			// sizeType
			// 
			this.sizeType.Items.AddRange(new object[] {
														  "MB",
														  "GB"});
			this.sizeType.Location = new System.Drawing.Point(208, 72);
			this.sizeType.Name = "sizeType";
			this.sizeType.Size = new System.Drawing.Size(72, 21);
			this.sizeType.TabIndex = 3;
			this.sizeType.Text = "MB";
			// 
			// sort
			// 
			this.sort.Location = new System.Drawing.Point(104, 104);
			this.sort.Name = "sort";
			this.sort.Size = new System.Drawing.Size(112, 23);
			this.sort.TabIndex = 4;
			this.sort.Text = "Separate Files";
			this.sort.Click += new System.EventHandler(this.sort_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(48, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 5;
			this.label1.Text = "Source:";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(24, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(76, 23);
			this.label2.TabIndex = 6;
			this.label2.Text = "Destination:";
			// 
			// destination
			// 
			this.destination.Location = new System.Drawing.Point(104, 48);
			this.destination.Name = "destination";
			this.destination.Size = new System.Drawing.Size(480, 20);
			this.destination.TabIndex = 7;
			this.destination.Text = "";
			// 
			// pickDestination
			// 
			this.pickDestination.Image = ((System.Drawing.Image)(resources.GetObject("pickDestination.Image")));
			this.pickDestination.Location = new System.Drawing.Point(584, 48);
			this.pickDestination.Name = "pickDestination";
			this.pickDestination.Size = new System.Drawing.Size(32, 23);
			this.pickDestination.TabIndex = 8;
			this.pickDestination.Click += new System.EventHandler(this.pickDestination_Click);
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(32, 72);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(76, 23);
			this.label3.TabIndex = 9;
			this.label3.Text = "Max Size:";
			// 
			// status
			// 
			this.status.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.status.ForeColor = System.Drawing.Color.Red;
			this.status.Location = new System.Drawing.Point(224, 112);
			this.status.Name = "status";
			this.status.Size = new System.Drawing.Size(232, 16);
			this.status.TabIndex = 10;
			// 
			// FileDivider
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 158);
			this.Controls.Add(this.status);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.pickDestination);
			this.Controls.Add(this.destination);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.sort);
			this.Controls.Add(this.sizeType);
			this.Controls.Add(this.size);
			this.Controls.Add(this.Browse);
			this.Controls.Add(this.folder);
			this.Name = "FileDivider";
			this.Text = "File Separator";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FileDivider());
		}

		/// <summary>
		/// Handles the the click event for the sort files button
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void sort_Click(object sender, System.EventArgs e)
		{
			if(Directory.Exists(this.folder.Text))
			{
				Thread runner = new Thread(new ThreadStart(SeparateFiles));
				runner.Start();
			}
			else
			{
				MessageBox.Show(this,"The source directory does not exist");
			}
		
		}



		/// <summary>
		/// Handles the source folder browse button click event
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Browse_Click(object sender, System.EventArgs e)
		{
			folderBrowserDialog1.SelectedPath = folder.Text;
			if(this.folderBrowserDialog1.ShowDialog() == DialogResult.OK)
			{
				folder.Text = folderBrowserDialog1.SelectedPath;
			}

		}

		/// <summary>
		/// Handles the destination folder browse button click event
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void pickDestination_Click(object sender, System.EventArgs e)
		{
			folderBrowserDialog2.SelectedPath = destination.Text;
			
			if(this.folderBrowserDialog2.ShowDialog() == DialogResult.OK)
			{
				destination.Text = folderBrowserDialog2.SelectedPath;
			}
		
		}

		/// <summary>
		/// Performs the file separation task.
		/// </summary>
		private void SeparateFiles()
		{
			/* General flow
			 * ---------------------
			 * First get a list of all the files in the source folder and add the file info to the packer
			 * Then execute the packing algorithm
			 * For each packed bin, create a sub folder in the destionation
			 *		and copy the files in the source folder to the destination
			 * */


			status.Text = "Initializing";
			this.Refresh();
			// we need to compute the maximum sze of our folders
			double maximumSize = double.Parse(this.size.Text);
			if(sizeType.Text == "MB")
				maximumSize = maximumSize * 1048576.0;
			else if(sizeType.Text == "GB")
				maximumSize = maximumSize * 1073741824.0;
			else
				throw(new ArgumentException("Please choose a valid file size type"));

			BinPacker packer = new BinPacker(maximumSize);

			
			// we need to loop through the source folder and add references to the files
			// to our bin packer
			foreach(string file in Directory.GetFiles(folder.Text))
			{
				FileInfo fileData = new FileInfo(file);
				packer.AddItem(Convert.ToDouble(fileData.Length),fileData);
			}

			status.Text = "Packing";
			this.Refresh();
			
			// pack the bin, we are specifically catching the PackingException in case one or more
			// of our files are too big.
			try
			{
				packer.Pack(PackingMode.Fast);
			}
			catch(PackingException e)
			{
				MessageBox.Show(this,"One or more files in the source directory are larger than the maximum directory size");
				status.Text = "Failed";
				this.Refresh();
				return;
			}
 
			status.Text = "Copying Files";
			this.Refresh();
			// now write the sorted files to the destination directory.
			// create a sub-directory for each bin and copy the source
			// files to the new subdirectory.  If a subdirecory exists
			// delete it.
			string baseDirectory = destination.Text;
			if(!Directory.Exists(baseDirectory))
				Directory.CreateDirectory(baseDirectory);
				
			for(int i=0;i<packer.Bins.Count;i++)
			{
				string newDirectory = Path.Combine(baseDirectory,(i+1).ToString());
				if(Directory.Exists(newDirectory))
					Directory.Delete(newDirectory);

				Directory.CreateDirectory(newDirectory);

				foreach(BinItem item in packer.Bins[i])
				{
					FileInfo file = (FileInfo) item.Value;
					file.CopyTo(Path.Combine(newDirectory,file.Name),true);
				}

			}

			status.Text = "Complete!";
			this.Refresh();
		
		}

		
	}
}
